'use strict'

var angular = require('angular');

/* CONTROLLER DECLARATION TEMPLATE

angular.module('rando.custom').controller('NameOfYourCustomController', function (aDependency, anotherDependency) {
    
});

/!\ the name of the module must be 'rando.custom', otherwise you'll get an error of a non existing module.

HINT: You can declare as many controllers as you whish
HINT2: You'll probably need $scope and $rootScope as dependencies
HINT3: To access map instance, use $rootScope.map

*/


function HomeVideoController() {

    function equalHeightVignette(){
        var nbSpan = jQuery('#vignettes span').length;
        var heightMax = 0;
        for (var i=0; i < nbSpan; i++){
            if(jQuery('#vignettes span').eq(i).height() > heightMax){
                heightMax = jQuery('#vignettes span').eq(i).height();
            }
        }

        jQuery('#vignettes span').height(heightMax+'px');
    }

    function initHomeVideo() {
        if( /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent) ) {
             //Mobile => pas de video juste l'image
             //alert("MOBILE DETECTER");
        } else {
            var video = document.getElementById("video-balades");
            if(video != null){
              //setTimeout("video.play()", 3000);
              //On lance maintenant directement la vidéo
              video.play();
            }
        }

          //resize

        equalHeightVignette();

        jQuery(window).resize(function(){

            jQuery('#vignettes span').removeAttr('style');
            equalHeightVignette();

        });
    }
    initHomeVideo();
}

function HomeFeedController($scope, $http, googleapiService) {

    /**
     * jQuery plugin to convert a given $.ajax response xml object to json.
     *
     * @example var json = $.xml2json(response);
     */
    function loadXML2JSON() {

        // default options based on https://github.com/Leonidas-from-XIV/node-xml2js
        var defaultOptions = {
            attrkey: '$',
            charkey: '_',
            normalize: false,
            explicitArray: false
        };

        // extracted from jquery
        function parseXML(data) {
            var xml, tmp;
            if (!data || typeof data !== "string") {
                return null;
            }
            try {
                if (window.DOMParser) { // Standard
                    tmp = new DOMParser();
                    xml = tmp.parseFromString(data, "text/xml");
                } else { // IE
                    xml = new ActiveXObject("Microsoft.XMLDOM");
                    xml.async = "false";
                    xml.loadXML(data);
                }
            } catch (e) {
                xml = undefined;
            }
            if (!xml || !xml.documentElement || xml.getElementsByTagName("parsererror").length) {
                throw new Error("Invalid XML: " + data);
            }
            return xml;
        }

        function normalize(value, options){
            if (!!options.normalize){
                return (value || '').trim();
            }
            return value;
        }

        function xml2jsonImpl(xml, options) {

            var i, result = {}, attrs = {}, node, child, name;
            result[options.attrkey] = attrs;

            if (xml.attributes && xml.attributes.length > 0) {
                for (i = 0; i < xml.attributes.length; i++){
                    var item = xml.attributes.item(i);
                    attrs[item.nodeName] = item.value;
                }
            }

            // element content
            if (xml.childElementCount === 0) {
                result[options.charkey] = normalize(xml.textContent, options);
            }

            for (i = 0; i < xml.childNodes.length; i++) {
                node = xml.childNodes[i];
                if (node.nodeType === 1) {

                    if (node.attributes.length === 0 && node.childElementCount === 0){
                        child = normalize(node.textContent, options);
                    } else {
                        child = xml2jsonImpl(node, options);
                    }

                    name = node.nodeName;
                    if (result.hasOwnProperty(name)) {
                        // For repeating elements, cast/promote the node to array
                        var val = result[name];
                        if (!Array.isArray(val)) {
                            val = [val];
                            result[name] = val;
                        }
                        val.push(child);
                    } else if(options.explicitArray === true) {
                        result[name] = [child];
                    } else {
                        result[name] = child;
                    }
                }
            }

            return result;
        }

        /**w
         * Converts an xml document or string to a JSON object.
         *
         * @param xml
         */
        function xml2json(xml, options) {
            var n;

            if (!xml) {
                return xml;
            }

            options = options || {};

            for(n in defaultOptions) {
                if(defaultOptions.hasOwnProperty(n) && options[n] === undefined) {
                    options[n] = defaultOptions[n];
                }
            }

            if (typeof xml === 'string') {
                xml = parseXML(xml).documentElement;
            }

            var root = {};
            if (typeof xml.attributes === 'undefined') {
                root[xml.nodeName] = xml2jsonImpl(xml, options);
            } else if (xml.attributes.length === 0 && xml.childElementCount === 0){
                root[xml.nodeName] = normalize(xml.textContent, options);
            } else {
                root[xml.nodeName] = xml2jsonImpl(xml, options);
            }

            return root;
        }

        if (typeof jQuery !== 'undefined') {
            jQuery.extend({xml2json: xml2json});
        } else if (typeof module !== 'undefined') {
            module.exports = xml2json;
        } else if (typeof window !== 'undefined') {
            window.xml2json = xml2json;
        }
    }

    function addRssEventOnHome(entry){

        var xmlNodeToJson = jQuery.xml2json(entry.xmlNode);

        var cityName = xmlNodeToJson.item['event:city_name'];
        var typeName = xmlNodeToJson.item['event:type'];

        var dateFrom      = new Date(xmlNodeToJson.item['event:date_from']);
        var dateTo        = new Date(xmlNodeToJson.item['event:date_to']);
        var dateString    = dateToString(dateFrom, dateTo);

        var rss_container = document.getElementById('evenements');

        //create div event
        var divEvent  = documentCreateDiv('evenement');
        var divDotted = documentCreateDiv('dotted evenement_dotted');

        //create title
        var titlePara = documentCreatePara('', 'evenement_title');
        titlePara.appendChild(documentCreateLink(entry.title, entry.link));

        //create date
        var datePara = documentCreatePara(dateString, 'evenement_date');

        var descriptionPara = documentCreatePara(cityName + ' - ' + typeName, 'evenement_information');

        divDotted.appendChild(titlePara);
        divDotted.appendChild(datePara);
        divDotted.appendChild(descriptionPara);

        divEvent.appendChild(divDotted);

        rss_container.appendChild(divEvent);
    }

    function documentCreateLink(label, href){
        var link = document.createElement('a');
        link.href = href;
        link.appendChild(document.createTextNode(label));

        return link;
    }

    function documentCreateDiv(className){
        var div        = document.createElement('div');
        div.className  = className;

        return div;
    }

    function documentCreatePara(text, className){
        var para       = document.createElement('p');
        var textNode   = document.createTextNode(text);

        para.className = className;
        para.appendChild(textNode);

        return para;
    }

    function dateToString(dateFrom, dateTo){
        if(areDateEquals(dateFrom, dateTo)){
            return singleDateString(dateFrom);
        }
        else{
            return intervalDateString(dateFrom, dateTo);
        }
    }

    function intervalDateString(date1, date2){
        return 'Du ' + date1.getDate() + ' ' + $scope.dates.months[date1.getMonth()] + ' au ' + date2.getDate() + ' ' + $scope.dates.months[date2.getMonth()];
    }

    function singleDateString(date){
        return $scope.dates.days[date.getDay()] + ' ' + date.getDate() + ' ' + $scope.dates.months[date.getMonth()];
    }

    function areDateEquals(date1, date2){
        if(date1.getDate() == date2.getDate() && date1.getMonth() == date2.getMonth() && date1.getYear() == date2.getYear()){
            return true;
        }
        else{
            return false;
        }
    }

    function loadFeed() {
        var FEED_URL    = 'http://www.loire-atlantique.fr/plugins/CorporateIdentityPlugin/jsp/rss/doRSS.jsp?idCat=c_5063&creationPeriod=999&allOrga=true&genres=p2_275473&%20p2_275475&%20p2_275477';
        var NUM_ENTRIES = 4;

        $scope.dates = {
            "months" : [
                "Janvier",
                "Février",
                "Mars",
                "Avril",
                "Mai",
                "Juin",
                "Juillet",
                "Août",
                "Septembre",
                "Octobre",
                "Novembre",
                "Décembre"
            ],
            "days" : [
                "Dimanche",
                "Lundi",
                "Mardi",
                "Mercredi",
                "Jeudi",
                "Vendredi",
                "Samedi"
            ]
        };

        var feed = new google.feeds.Feed(FEED_URL);
        feed.setNumEntries(NUM_ENTRIES);
        feed.setResultFormat(google.feeds.Feed.MIXED_FORMAT);
        feed.load(function (result) {
            var days   = $scope.dates.days;
            var months = $scope.dates.months;

            // Parse data, result format is JSON.
            for (var i = 0; i < result.feed.entries.length; i++) {
                var entry = result.feed.entries[i];
                addRssEventOnHome(entry);
            }
        });
    }

    googleapiService.checkAPI()
        .then(
            function () {
                loadXML2JSON();
                google.load("feeds", "1", {"callback" : loadFeed});
            }
        );
}

angular.module('rando.custom').controller('HomeFeedController', HomeFeedController);

angular.module('rando.custom').controller('HomeVideoController', HomeVideoController);

module.exports = {
    HomeVideoController: HomeVideoController,
    HomeFeedController: HomeFeedController
};
